<template>
  <li class="cards_item">
    <div class="card">
      <div
        v-if="item.urlToImage"
        class="card_image"
        v-bind:style="{
          'background-image': 'url(' + item.urlToImage + ')',
        }"
      ></div>
      <div v-else class="card_image no_image"></div>
      <div class="card_content">
        <div class="card_title">{{ item.title }}</div>
        <p class="sourceText">
          {{ item.source.name }}
        </p>
        <p class="card_text">
          {{ item.description }}
        </p>
        <button @click="onDtails(item)" class="card_btn">
          Go to page
        </button>
        <button class="book-mark" @click="bookmark(item)">
          <svg
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 40 40"
            width="40px"
            height="80px"
          >
            <path
              :fill="checkAlreadyBooked(item)"
              d="M20 31.441L8.5 37.191 8.5 2.5 31.5 2.5 31.5 37.191z"
            />
            <path
              fill="#c74343"
              d="M31,3v33.382l-10.553-5.276L20,30.882l-0.447,0.224L9,36.382V3H31 M32,2H8v36l12-6l12,6V2L32,2z"
            />
          </svg>
        </button>
      </div>
      <div class="publish_date">
        {{ getFormattedDate(item.publishedAt) }}
      </div>
    </div>
  </li>
</template>
<script>
export default {
  props: {
    item: Object,
  },
  computed: {
    getBookmarked() {
      return this.$store.getters.getBookmarked;
    },
  },
  methods: {
    getFormattedDate(date) {
      const time = new Date(date);
      let month = time.getMonth() + 1;
      const day = time.getDate();
      const year = time.getFullYear();
      return month + "/" + day + "/" + year;
    },
    onDtails(item) {
      this.$store.dispatch("setDetailItem", item).then(() => {
        this.$router.replace("/details");
      });
    },
    bookmark(item) {
      if (item.isBookmarked) item.isBookmarked = false;
      else item.isBookmarked = true;
      this.$store.dispatch("setBookmarked", item);
    },
    checkAlreadyBooked(item) {
      const index = this.getBookmarked.findIndex((x) => x.title === item.title);
      if (index !== -1) {
        item.isBookmarked = true;
      }
      return item.isBookmarked ? "#f78f8f" : "#fff";
    },
  },
};
</script>
<style scopped>
.card_btn:hover {
  background-color: green;
}
.card_btn {
  background-color: #777777;
  border: none;
  color: white;
  padding: 8px 10px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 16px;
  border-radius: 5px;
}

.cards_item {
  display: flex;
  padding: 10px;
}
@media (min-width: 40rem) {
  .cards_item {
    width: 50%;
  }
}
@media (min-width: 56rem) {
  .cards_item {
    width: 25%;
  }
}
.card {
  background-color: white;
  border-radius: 0.25rem;
  box-shadow: 0 20px 40px -14px rgba(0, 0, 0, 0.25);
  display: flex;
  flex-direction: column;
  overflow: hidden;
  position: relative;
  padding-bottom: 40px;
}
.card:hover .card_image {
  filter: contrast(100%);
}
.card_content {
  padding: 10px;
  text-align: left;
}
.card_image {
  background-position: center center;
  background-repeat: no-repeat;
  background-size: cover;
  border-top-left-radius: 0.25rem;
  border-top-right-radius: 0.25rem;
  filter: contrast(70%);
  overflow: hidden;
  position: relative;
  transition: filter 0.5s cubic-bezier(0.43, 0.41, 0.22, 0.91);
}
.card_image::before {
  content: "";
  display: block;
  padding-top: 56.25%;
}
@media (min-width: 40rem) {
  .card_image::before {
    padding-top: 66.6%;
  }
}
.card_text {
  flex: 1 1 auto;
  font-size: 11px;
  line-height: 1.5;
  margin-bottom: 1.25rem;
}
.publish_date {
  padding: 14px 10px;
  text-align: left;
  font-size: 12px;
  background: #eaeaea;
  color: #6d6d6d;
  position: absolute;
  bottom: 0;
  width: 100%;
  border-top: 1px solid #ccc;
}
.sourceText {
  font-size: 15px;
  font-weight: bold;
  color: #949494;
  margin: 5px 0 0 0;
}
.no_image:after {
  content: "Image not available";
  position: absolute;
  height: 100%;
  width: 100%;
  left: 0;
  top: 0;
  vertical-align: middle;
  display: grid;
  align-items: center;
  color: #eaeaea;
}
.book-mark {
  background: none;
  border: none;
  float: right;
}
.book-mark svg {
  width: 39px;
  height: 30px;
}
</style>
